diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -7060,17 +2529,14 @@ region_model::get_fndecl_for_call (const gcall *call,
   tree fn_ptr = gimple_call_fn (call);
   if (fn_ptr == NULL_TREE)
     return NULL_TREE;
-  svalue_id fn_ptr_sid = get_rvalue (fn_ptr, ctxt);
-  svalue *fn_ptr_sval = get_svalue (fn_ptr_sid);
-  if (region_svalue *fn_ptr_ptr = fn_ptr_sval->dyn_cast_region_svalue ())
+  const svalue *fn_ptr_sval = get_rvalue (fn_ptr, ctxt);
+  if (const region_svalue *fn_ptr_ptr
+	= fn_ptr_sval->dyn_cast_region_svalue ())
     {
-      region_id fn_rid = fn_ptr_ptr->get_pointee ();
-      code_region *code = get_root_region ()->get_code_region (this);
-      if (code)
+      const region *reg = fn_ptr_ptr->get_pointee ();
+      if (const function_region *fn_reg = reg->dyn_cast_function_region ())
 	{
-	  tree fn_decl = code->get_tree_for_child_region (fn_rid);
-	  if (!fn_decl)
-	    return NULL_TREE;
+	  tree fn_decl = fn_reg->get_fndecl ();
 	  cgraph_node *node = cgraph_node::get (fn_decl);
 	  if (!node)
 	    return NULL_TREE;
@@ -7083,339 +2549,136 @@ region_model::get_fndecl_for_call (const gcall *call,
   return NULL_TREE;
 }
 
-/* struct model_merger.  */
-
-/* Dump a multiline representation of this merger to PP.  */
+/* Would be much simpler to use a lambda here, if it were supported.  */
 
-void
-model_merger::dump_to_pp (pretty_printer *pp) const
+struct append_ssa_names_cb_data
 {
-  pp_string (pp, "model A:");
-  pp_newline (pp);
-  m_model_a->dump_to_pp (pp, false);
-  pp_newline (pp);
-
-  pp_string (pp, "model B:");
-  pp_newline (pp);
-  m_model_b->dump_to_pp (pp, false);
-  pp_newline (pp);
-
-  pp_string (pp, "merged model:");
-  pp_newline (pp);
-  m_merged_model->dump_to_pp (pp, false);
-  pp_newline (pp);
-
-  pp_string (pp, "region map: model A to merged model:");
-  pp_newline (pp);
-  m_map_regions_from_a_to_m.dump_to_pp (pp);
-  pp_newline (pp);
-
-  pp_string (pp, "region map: model B to merged model:");
-  pp_newline (pp);
-  m_map_regions_from_b_to_m.dump_to_pp (pp);
-  pp_newline (pp);
-
-  m_sid_mapping->dump_to_pp (pp);
-}
+  const region_model *model;
+  auto_vec<const decl_region *> *out;
+};
 
-/* Dump a multiline representation of this merger to FILE.  */
+/* Populate *OUT with all decl_regions for SSA names in the current
+   frame that have clusters within the store.  */
 
 void
-model_merger::dump (FILE *fp) const
-{
-  pretty_printer pp;
-  pp_format_decoder (&pp) = default_tree_printer;
-  pp_show_color (&pp) = pp_show_color (global_dc->printer);
-  pp.buffer->stream = fp;
-  dump_to_pp (&pp);
-  pp_flush (&pp);
-}
-
-/* Dump a multiline representation of this merger to stderr.  */
-
-DEBUG_FUNCTION void
-model_merger::dump () const
+region_model::
+get_ssa_name_regions_for_current_frame (auto_vec<const decl_region *> *out)
+  const
 {
-  dump (stderr);
+  append_ssa_names_cb_data data;
+  data.model = this;
+  data.out = out;
+  m_store.for_each_cluster (append_ssa_names_cb, &data);
 }
 
-/* Attempt to merge the svalues of SID_A and SID_B (from their
-   respective models), writing the id of the resulting svalue
-   into *MERGED_SID.
-   Return true if the merger is possible, false otherwise.  */
+/* Implementation detail of get_ssa_name_regions_for_current_frame.  */
 
-bool
-model_merger::can_merge_values_p (svalue_id sid_a,
-				  svalue_id sid_b,
-				  svalue_id *merged_sid)
+void
+region_model::append_ssa_names_cb (const region *base_reg,
+				   append_ssa_names_cb_data *cb_data)
 {
-  gcc_assert (merged_sid);
-  svalue *sval_a = m_model_a->get_svalue (sid_a);
-  svalue *sval_b = m_model_b->get_svalue (sid_b);
-
-  /* If both are NULL, then the "values" are trivially mergeable.  */
-  if (!sval_a && !sval_b)
-    return true;
-
-  /* If one is NULL and the other non-NULL, then the "values"
-     are not mergeable.  */
-  if (!(sval_a && sval_b))
-    return false;
-
-  /* Have they both already been mapped to the same new svalue_id?
-     If so, use it.  */
-  svalue_id sid_a_in_m
-    = m_sid_mapping->m_map_from_a_to_m.get_dst_for_src (sid_a);
-  svalue_id sid_b_in_m
-    = m_sid_mapping->m_map_from_b_to_m.get_dst_for_src (sid_b);
-  if (!sid_a_in_m.null_p ()
-      && !sid_b_in_m.null_p ()
-      && sid_a_in_m == sid_b_in_m)
-    {
-      *merged_sid = sid_a_in_m;
-      return true;
-    }
-
-  tree type = sval_a->get_type ();
-  if (type == NULL_TREE)
-    type = sval_b->get_type ();
-
-  /* If the values have different kinds, or are both unknown,
-     then merge as "unknown".  */
-  if (sval_a->get_kind () != sval_b->get_kind ()
-      || sval_a->get_kind () == SK_UNKNOWN)
-    {
-      svalue *merged_sval = new unknown_svalue (type);
-      *merged_sid = m_merged_model->add_svalue (merged_sval);
-      record_svalues (sid_a, sid_b, *merged_sid);
-      return true;
-    }
-
-  gcc_assert (sval_a->get_kind () == sval_b->get_kind ());
-
-  switch (sval_a->get_kind ())
+  if (base_reg->get_parent_region () != cb_data->model->m_current_frame)
+    return;
+  if (const decl_region *decl_reg = base_reg->dyn_cast_decl_region ())
     {
-    default:
-    case SK_UNKNOWN: /* SK_UNKNOWN handled above.  */
-       gcc_unreachable ();
-
-    case SK_REGION:
-      {
-	/* If we have two region pointers, then we can merge (possibly to
-	   "unknown").  */
-	const region_svalue &region_sval_a = *as_a <region_svalue *> (sval_a);
-	const region_svalue &region_sval_b = *as_a <region_svalue *> (sval_b);
-	region_svalue::merge_values (region_sval_a, region_sval_b,
-				     merged_sid, type,
-				     this);
-	record_svalues (sid_a, sid_b, *merged_sid);
-	return true;
-      }
-      break;
-    case SK_CONSTANT:
-      {
-	/* If we have two constants, then we can merge.  */
-	const constant_svalue &cst_sval_a = *as_a <constant_svalue *> (sval_a);
-	const constant_svalue &cst_sval_b = *as_a <constant_svalue *> (sval_b);
-	constant_svalue::merge_values (cst_sval_a, cst_sval_b,
-				       merged_sid, this);
-	record_svalues (sid_a, sid_b, *merged_sid);
-	return true;
-      }
-      break;
-
-    case SK_POISONED:
-    case SK_SETJMP:
-      return false;
+      if (TREE_CODE (decl_reg->get_decl ()) == SSA_NAME)
+	cb_data->out->safe_push (decl_reg);
     }
 }
 
-/* Record that A_RID in model A and B_RID in model B
-   correspond to MERGED_RID in the merged model, so
-   that pointers can be accurately merged.  */
-
-void
-model_merger::record_regions (region_id a_rid,
-			      region_id b_rid,
-			      region_id merged_rid)
-{
-  m_map_regions_from_a_to_m.put (a_rid, merged_rid);
-  m_map_regions_from_b_to_m.put (b_rid, merged_rid);
-}
-
-/* Record that A_SID in model A and B_SID in model B
-   correspond to MERGED_SID in the merged model.  */
-
-void
-model_merger::record_svalues (svalue_id a_sid,
-			      svalue_id b_sid,
-			      svalue_id merged_sid)
-{
-  gcc_assert (m_sid_mapping);
-  m_sid_mapping->m_map_from_a_to_m.put (a_sid, merged_sid);
-  m_sid_mapping->m_map_from_b_to_m.put (b_sid, merged_sid);
-}
-
-/* struct svalue_id_merger_mapping.  */
-
-/* svalue_id_merger_mapping's ctor.  */
+/* Return a new region describing a heap-allocated block of memory.  */
 
-svalue_id_merger_mapping::svalue_id_merger_mapping (const region_model &a,
-						    const region_model &b)
-: m_map_from_a_to_m (a.get_num_svalues ()),
-  m_map_from_b_to_m (b.get_num_svalues ())
+const region *
+region_model::create_region_for_heap_alloc (const svalue *size_in_bytes)
 {
+  const region *reg = m_mgr->create_region_for_heap_alloc ();
+  record_dynamic_extents (reg, size_in_bytes);
+  return reg;
 }
 
-/* Dump a multiline representation of this to PP.  */
+/* Return a new region describing a block of memory allocated within the
+   current frame.  */
 
-void
-svalue_id_merger_mapping::dump_to_pp (pretty_printer *pp) const
+const region *
+region_model::create_region_for_alloca (const svalue *size_in_bytes)
 {
-  pp_string (pp, "svalue_id map: model A to merged model:");
-  pp_newline (pp);
-  m_map_from_a_to_m.dump_to_pp (pp);
-  pp_newline (pp);
-
-  pp_string (pp, "svalue_id map: model B to merged model:");
-  pp_newline (pp);
-  m_map_from_b_to_m.dump_to_pp (pp);
-  pp_newline (pp);
+  const region *reg = m_mgr->create_region_for_alloca (m_current_frame);
+  record_dynamic_extents (reg, size_in_bytes);
+  return reg;
 }
 
-/* Dump a multiline representation of this to FILE.  */
+/* Placeholder hook for recording that the size of REG is SIZE_IN_BYTES.
+   Currently does nothing.  */
 
 void
-svalue_id_merger_mapping::dump (FILE *fp) const
-{
-  pretty_printer pp;
-  pp_format_decoder (&pp) = default_tree_printer;
-  pp_show_color (&pp) = pp_show_color (global_dc->printer);
-  pp.buffer->stream = fp;
-  dump_to_pp (&pp);
-  pp_flush (&pp);
-}
-
-/* Dump a multiline representation of this to stderr.  */
-
-DEBUG_FUNCTION void
-svalue_id_merger_mapping::dump () const
+region_model::
+record_dynamic_extents (const region *reg ATTRIBUTE_UNUSED,
+			const svalue *size_in_bytes ATTRIBUTE_UNUSED)
 {
-  dump (stderr);
 }
 
-/* struct canonicalization.  */
-
-/* canonicalization's ctor.  */
-
-canonicalization::canonicalization (const region_model &model)
-: m_model (model),
-  m_rid_map (model.get_num_regions ()),
-  m_sid_map (model.get_num_svalues ()),
-  m_next_rid_int (0),
-  m_next_sid_int (0)
-{
-}
-
-/* If we've not seen RID yet, assign it a canonicalized region_id,
-   and walk the region's svalue and then the region.  */
-
-void
-canonicalization::walk_rid (region_id rid)
-{
-  /* Stop if we've already seen RID.  */
-  if (!m_rid_map.get_dst_for_src (rid).null_p ())
-    return;
-
-  region *region = m_model.get_region (rid);
-  if (region)
-    {
-      m_rid_map.put (rid, region_id::from_int (m_next_rid_int++));
-      walk_sid (region->get_value_direct ());
-      region->walk_for_canonicalization (this);
-    }
-}
+/* struct model_merger.  */
 
-/* If we've not seen SID yet, assign it a canonicalized svalue_id,
-   and walk the svalue (and potentially regions e.g. for ptr values).  */
+/* Dump a multiline representation of this merger to PP.  */
 
 void
-canonicalization::walk_sid (svalue_id sid)
+model_merger::dump_to_pp (pretty_printer *pp, bool simple) const
 {
-  /* Stop if we've already seen SID.  */
-  if (!m_sid_map.get_dst_for_src (sid).null_p ())
-    return;
-
-  svalue *sval = m_model.get_svalue (sid);
-  if (sval)
-    {
-      m_sid_map.put (sid, svalue_id::from_int (m_next_sid_int++));
-      /* Potentially walk regions e.g. for ptrs.  */
-      sval->walk_for_canonicalization (this);
-    }
-}
-
-/* Dump a multiline representation of this to PP.  */
+  pp_string (pp, "model A:");
+  pp_newline (pp);
+  m_model_a->dump_to_pp (pp, simple, true);
+  pp_newline (pp);
 
-void
-canonicalization::dump_to_pp (pretty_printer *pp) const
-{
-  pp_string (pp, "region_id map:");
+  pp_string (pp, "model B:");
   pp_newline (pp);
-  m_rid_map.dump_to_pp (pp);
+  m_model_b->dump_to_pp (pp, simple, true);
   pp_newline (pp);
 
-  pp_string (pp, "svalue_id map:");
+  pp_string (pp, "merged model:");
   pp_newline (pp);
-  m_sid_map.dump_to_pp (pp);
+  m_merged_model->dump_to_pp (pp, simple, true);
   pp_newline (pp);
 }
 
-/* Dump a multiline representation of this to FILE.  */
+/* Dump a multiline representation of this merger to FILE.  */
 
 void
-canonicalization::dump (FILE *fp) const
+model_merger::dump (FILE *fp, bool simple) const
 {
   pretty_printer pp;
   pp_format_decoder (&pp) = default_tree_printer;
   pp_show_color (&pp) = pp_show_color (global_dc->printer);
   pp.buffer->stream = fp;
-  dump_to_pp (&pp);
+  dump_to_pp (&pp, simple);
   pp_flush (&pp);
 }
 
-/* Dump a multiline representation of this to stderr.  */
+/* Dump a multiline representation of this merger to stderr.  */
 
 DEBUG_FUNCTION void
-canonicalization::dump () const
+model_merger::dump (bool simple) const
 {
-  dump (stderr);
+  dump (stderr, simple);
 }
 
 } // namespace ana
 
-/* Update HSTATE with a hash of SID.  */
+/* Dump RMODEL fully to stderr (i.e. without summarization).  */
 
-void
-inchash::add (svalue_id sid, inchash::hash &hstate)
+DEBUG_FUNCTION void
+debug (const region_model &rmodel)
 {
-  hstate.add_int (sid.as_int ());
+  rmodel.dump (false);
 }
 
-/* Update HSTATE with a hash of RID.  */
-
-void
-inchash::add (region_id rid, inchash::hash &hstate)
-{
-  hstate.add_int (rid.as_int ());
-}
+/* class engine.  */
 
-/* Dump RMODEL fully to stderr (i.e. without summarization).  */
+/* Dump the managed objects by class to LOGGER, and the per-class totals.  */
 
-DEBUG_FUNCTION void
-debug (const region_model &rmodel)
+void
+engine::log_stats (logger *logger) const
 {
-  rmodel.dump (false);
+  m_mgr.log_stats (logger, true);
 }
 
 namespace ana {
@@ -7480,9 +2743,21 @@ test_tree_cmp_on_constants ()
 
 void
 assert_condition (const location &loc,
-		  region_model &model,
-		  tree lhs, tree_code op, tree rhs,
-		  tristate expected)
+		   region_model &model,
+		   const svalue *lhs, tree_code op, const svalue *rhs,
+		   tristate expected)
+{
+  tristate actual = model.eval_condition (lhs, op, rhs);
+  ASSERT_EQ_AT (loc, actual, expected);
+}
+
+/* Implementation detail of the ASSERT_CONDITION_* macros.  */
+
+void
+assert_condition (const location &loc,
+		   region_model &model,
+		   tree lhs, tree_code op, tree rhs,
+		   tristate expected)
 {
   tristate actual = model.eval_condition (lhs, op, rhs, NULL);
   ASSERT_EQ_AT (loc, actual, expected);
@@ -7518,7 +2793,8 @@ assert_dump_eq (const location &loc,
   auto_fix_quotes sentinel;
   pretty_printer pp;
   pp_format_decoder (&pp) = default_tree_printer;
-  model.dump_to_pp (&pp, summarize);
+
+  model.dump_to_pp (&pp, summarize, true);
   ASSERT_STREQ_AT (loc, pp_formatted_text (&pp), expected);
 }
 
@@ -7534,21 +2810,21 @@ assert_dump_eq (const location &loc,
 static void
 test_dump ()
 {
-  region_model model;
-  model.get_root_region ()->ensure_stack_region (&model);
-  model.get_root_region ()->ensure_globals_region (&model);
-  model.get_root_region ()->ensure_heap_region (&model);
+  region_model_manager mgr;
+  region_model model (&mgr);
 
   ASSERT_DUMP_EQ (model, false,
-		  "r0: {kind: `root', parent: null, sval: null}\n"
-		  "|-stack: r1: {kind: `stack', parent: r0, sval: null}\n"
-		  "|-globals: r2: {kind: `globals', parent: r0, sval: null, map: {}}\n"
-		  "`-heap: r3: {kind: `heap', parent: r0, sval: null}\n"
-		  "svalues:\n"
-		  "constraint manager:\n"
+		  "stack depth: 0\n"
+		  "m_called_unknown_fn: FALSE\n"
+		  "constraint_manager:\n"
+		  "  equiv classes:\n"
+		  "  constraints:\n");
+  ASSERT_DUMP_EQ (model, true,
+		  "stack depth: 0\n"
+		  "m_called_unknown_fn: FALSE\n"
+		  "constraint_manager:\n"
 		  "  equiv classes:\n"
 		  "  constraints:\n");
-  ASSERT_DUMP_EQ (model, true, "");
 }
 
 /* Helper function for selftests.  Create a struct or union type named NAME,
@@ -7601,10 +2877,10 @@ struct coord_test
   tree m_coord_type;
 };
 
-/* Verify that dumps can show struct fields.  */
+/* Verify usage of a struct.  */
 
 static void
-test_dump_2 ()
+test_struct ()
 {
   coord_test ct;
 
@@ -7617,70 +2893,45 @@ test_dump_2 ()
   tree int_17 = build_int_cst (integer_type_node, 17);
   tree int_m3 = build_int_cst (integer_type_node, -3);
 
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   model.set_value (c_x, int_17, NULL);
   model.set_value (c_y, int_m3, NULL);
 
-  /* Simplified dump.  */
-  ASSERT_DUMP_EQ (model, true, "c.x: 17, c.y: -3");
-
-  /* Full dump.  */
-  ASSERT_DUMP_EQ
-    (model, false,
-     "r0: {kind: `root', parent: null, sval: null}\n"
-     "`-globals: r1: {kind: `globals', parent: r0, sval: null, map: {`c': r2}}\n"
-     "  `-`c': r2: {kind: `struct', parent: r1, sval: null, type: `struct coord', map: {`x': r3, `y': r4}}\n"
-     "    |: type: `struct coord'\n"
-     "    |-`x': r3: {kind: `primitive', parent: r2, sval: sv0, type: `int'}\n"
-     "    |  |: sval: sv0: {type: `int', `17'}\n"
-     "    |  |: type: `int'\n"
-     "    `-`y': r4: {kind: `primitive', parent: r2, sval: sv1, type: `int'}\n"
-     "      |: sval: sv1: {type: `int', `-3'}\n"
-     "      |: type: `int'\n"
-     "svalues:\n"
-     "  sv0: {type: `int', `17'}\n"
-     "  sv1: {type: `int', `-3'}\n"
-     "constraint manager:\n"
-     "  equiv classes:\n"
-     "  constraints:\n");
+  /* Verify get_offset for "c.x".  */
+  {
+    const region *c_x_reg = model.get_lvalue (c_x, NULL);
+    region_offset offset = c_x_reg->get_offset ();
+    ASSERT_EQ (offset.get_base_region (), model.get_lvalue (c, NULL));
+    ASSERT_EQ (offset.get_bit_offset (), 0);
+  }
+
+  /* Verify get_offset for "c.y".  */
+  {
+    const region *c_y_reg = model.get_lvalue (c_y, NULL);
+    region_offset offset = c_y_reg->get_offset ();
+    ASSERT_EQ (offset.get_base_region (), model.get_lvalue (c, NULL));
+    ASSERT_EQ (offset.get_bit_offset (), INT_TYPE_SIZE);
+  }
 }
 
-/* Verify that dumps can show array elements.  */
+/* Verify usage of an array element.  */
 
 static void
-test_dump_3 ()
+test_array_1 ()
 {
   tree tlen = size_int (10);
   tree arr_type = build_array_type (char_type_node, build_index_type (tlen));
 
   tree a = build_global_decl ("a", arr_type);
 
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   tree int_0 = build_int_cst (integer_type_node, 0);
   tree a_0 = build4 (ARRAY_REF, char_type_node,
 		     a, int_0, NULL_TREE, NULL_TREE);
   tree char_A = build_int_cst (char_type_node, 'A');
   model.set_value (a_0, char_A, NULL);
-
-  /* Simplified dump.  */
-  ASSERT_DUMP_EQ (model, true, "a[0]: 65");
-
-  /* Full dump.  */
-  ASSERT_DUMP_EQ
-    (model, false,
-     "r0: {kind: `root', parent: null, sval: null}\n"
-     "`-globals: r1: {kind: `globals', parent: r0, sval: null, map: {`a': r2}}\n"
-     "  `-`a': r2: {kind: `array', parent: r1, sval: null, type: `char[11]', array: {[0]: r3}}\n"
-     "    |: type: `char[11]'\n"
-     "    `-[0]: r3: {kind: `primitive', parent: r2, sval: sv1, type: `char'}\n"
-     "      |: sval: sv1: {type: `char', `65'}\n"
-     "      |: type: `char'\n"
-     "svalues:\n"
-     "  sv0: {type: `int', `0'}\n"
-     "  sv1: {type: `char', `65'}\n"
-     "constraint manager:\n"
-     "  equiv classes:\n"
-     "  constraints:\n");
 }
 
 /* Verify that region_model::get_representative_tree works as expected.  */
@@ -7688,27 +2939,96 @@ test_dump_3 ()
 static void
 test_get_representative_tree ()
 {
+  region_model_manager mgr;
+
   /* STRING_CST.  */
   {
     tree string_cst = build_string (4, "foo");
-    region_model m;
-    svalue_id str_sid = m.get_rvalue (string_cst, NULL);
-    tree rep = m.get_representative_tree (str_sid);
+    region_model m (&mgr);
+    const svalue *str_sval = m.get_rvalue (string_cst, NULL);
+    tree rep = m.get_representative_tree (str_sval);
     ASSERT_EQ (rep, string_cst);
   }
 
-  /* String literal.  */
+  /* String literal.  */
+  {
+    tree string_cst_ptr = build_string_literal (4, "foo");
+    region_model m (&mgr);
+    const svalue *str_sval = m.get_rvalue (string_cst_ptr, NULL);
+    tree rep = m.get_representative_tree (str_sval);
+    ASSERT_DUMP_TREE_EQ (rep, "&\"foo\"[0]");
+  }
+
+  /* Value of an element within an array.  */
+  {
+    tree tlen = size_int (10);
+    tree arr_type = build_array_type (char_type_node, build_index_type (tlen));
+    tree a = build_global_decl ("a", arr_type);
+    placeholder_svalue test_sval (char_type_node, "test value");
+
+    /* Value of a[3].  */
+    {
+      test_region_model_context ctxt;
+      region_model model (&mgr);
+      tree int_3 = build_int_cst (integer_type_node, 3);
+      tree a_3 = build4 (ARRAY_REF, char_type_node,
+			 a, int_3, NULL_TREE, NULL_TREE);
+      const region *a_3_reg = model.get_lvalue (a_3, &ctxt);
+      model.set_value (a_3_reg, &test_sval, &ctxt);
+      tree rep = model.get_representative_tree (&test_sval);
+      ASSERT_DUMP_TREE_EQ (rep, "a[3]");
+    }
+
+    /* Value of a[0].  */
+    {
+      test_region_model_context ctxt;
+      region_model model (&mgr);
+      tree idx = build_int_cst (integer_type_node, 0);
+      tree a_0 = build4 (ARRAY_REF, char_type_node,
+			 a, idx, NULL_TREE, NULL_TREE);
+      const region *a_0_reg = model.get_lvalue (a_0, &ctxt);
+      model.set_value (a_0_reg, &test_sval, &ctxt);
+      tree rep = model.get_representative_tree (&test_sval);
+      ASSERT_DUMP_TREE_EQ (rep, "a[0]");
+    }
+  }
+
+  /* Value of a field within a struct.  */
   {
-    tree string_cst_ptr = build_string_literal (4, "foo");
-    region_model m;
-    svalue_id str_sid = m.get_rvalue (string_cst_ptr, NULL);
-    tree rep = m.get_representative_tree (str_sid);
-    ASSERT_DUMP_TREE_EQ (rep, "&\"foo\"[0]");
+    coord_test ct;
+
+    tree c = build_global_decl ("c", ct.m_coord_type);
+    tree c_x = build3 (COMPONENT_REF, TREE_TYPE (ct.m_x_field),
+		       c, ct.m_x_field, NULL_TREE);
+    tree c_y = build3 (COMPONENT_REF, TREE_TYPE (ct.m_y_field),
+		       c, ct.m_y_field, NULL_TREE);
+
+    test_region_model_context ctxt;
+
+    /* Value of initial field.  */
+    {
+      region_model m (&mgr);
+      const region *c_x_reg = m.get_lvalue (c_x, &ctxt);
+      placeholder_svalue test_sval_x (integer_type_node, "test x val");
+      m.set_value (c_x_reg, &test_sval_x, &ctxt);
+      tree rep = m.get_representative_tree (&test_sval_x);
+      ASSERT_DUMP_TREE_EQ (rep, "c.x");
+    }
+
+    /* Value of non-initial field.  */
+    {
+      region_model m (&mgr);
+      const region *c_y_reg = m.get_lvalue (c_y, &ctxt);
+      placeholder_svalue test_sval_y (integer_type_node, "test y val");
+      m.set_value (c_y_reg, &test_sval_y, &ctxt);
+      tree rep = m.get_representative_tree (&test_sval_y);
+      ASSERT_DUMP_TREE_EQ (rep, "c.y");
+    }
   }
 }
 
 /* Verify that calling region_model::get_rvalue repeatedly on the same
-   tree constant retrieves the same svalue_id.  */
+   tree constant retrieves the same svalue *.  */
 
 static void
 test_unique_constants ()
